%define anolis_release 2

%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}perl\\(JSON::(Backend::PP|backportPP::Boolean|Boolean|PP|PP::IncrParser)\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}perl\\(JSON::(backportPP|backportPP::Boolean)\\)

Name:           perl-JSON
Summary:        Parse and convert to JSON (JavaScript Object Notation)
Version:        4.10
Release:        %{anolis_release}%{?dist}
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/JSON
Source0:        https://cpan.metacpan.org/modules/by-module/JSON/JSON-%{version}.tar.gz
BuildArch:      noarch
# Build
BuildRequires:  make coreutils findutils
BuildRequires:  perl(Config) perl-interpreter perl-generators
BuildRequires:  perl(:VERSION) >= 5.5.30 perl(lib) perl(ExtUtils::MakeMaker)
# Module
BuildRequires:  perl(constant) perl(B) perl(bytes) perl(Carp)
BuildRequires:  perl(strict) perl(overload) perl(Exporter) perl(Encode) perl(warnings)
BuildRequires:  perl(Math::BigInt) perl(Math::BigFloat) perl(Scalar::Util)
# Tests
BuildRequires:  perl(utf8) perl(Data::Dumper) perl(charnames) perl(Test::More) perl(vars)
BuildRequires:  perl(Tie::IxHash) perl(Tie::Hash) perl(Tie::Array)
# Optional tests
BuildRequires:  perl(Types::Serialiser) perl(JSON::XS) >= 4.00
# Dependencies
Requires:       perl(Encode) perl(warnings) perl(B)
Requires:       perl(Scalar::Util) perl(Math::BigInt) perl(Math::BigFloat)

Obsoletes:      %{name}-tests < %{EVR}

%{?perl_default_filter}

%description
This module is a thin wrapper for JSON::XS-compatible modules with a few additional features. All the 
backend modules convert a Perl data structure to a JSON text and vice versa. This module uses JSON::XS 
by default, and when JSON::XS is not available, falls back on JSON::PP, which is in the Perl core 
since 5.14. If JSON::PP is not available either, this module then falls back on JSON::backportPP 
(which is actually JSON::PP in a different .pm file) bundled in the same distribution as this module. 
You can also explicitly specify to use Cpanel::JSON::XS, a fork of JSON::XS by Reini Urban.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n JSON-%{version}

%build
/usr/bin/perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} -c %{buildroot}

%check
unset PERL_JSON_BACKEND PERL_JSON_DEBUG PERL_JSON_PP_USE_B
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
%{make_build} test

%files
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files doc
%doc README Changes

%changelog
* Sat Apr 15 2023 yuanhui <yuanhui@linux.alibaba.com> - 4.10-2
- Optimize the spec file

* Mon Jan 30 2023 Funda Wang <fundawang@yeah.net> - 4.10-1
- Import package for anolis 23
